<?php

namespace Drupal\reactify_menu\Plugin\rest\resource;

use Drupal\rest\Plugin\ResourceBase;
use Drupal\rest\ResourceResponse;

/**
 * Class MenuResource provides
 * menu endpoints
 *
 * @RestResource (
 *   id = "menu_resource",
 *   label = @Translation("Menu resource"),
 *   uri_paths = {
 *     "canonical" = "/rest/menu/{menu}"
 *   }
 * )
 *
 * @package Drupal\reactify\Plugin\rest\resource
 */

class MenuResource extends ResourceBase {
 /**
  * Responds to get requests.
  */
 public function get($menu) {
   $menu_name = $menu;
   $loaded_menu = \Drupal::menuTree()->load($menu_name,  new \Drupal\Core\Menu\MenuTreeParameters());
   $result = [];

   foreach ($loaded_menu as $item) {
     $link = $item->link;
     $url = $link->getUrlObject();
     array_push($result, [
       'id' => $link->getBaseId() . $link->getWeight(),
       'title' => $link->getTitle(),
       'url' => $url->getInternalPath(),
       //'alias' => Url::fromUri($url->getUri())->toString(),
       'weight' => $link->getWeight(),
     ]);
   };

   return new ResourceResponse($result);
 }
}
